﻿/*************************************************************************/
/*                                                                     							 	 */
/*      scribbler ::    Create radom offset effects in your text                     */
/*                                                                    								  */
/*      [Ver: 1.1]    [Author: Loic Aigon]    [Modif: 09/04/2010]      		 */
/*      [Lang: EN|FR]  [Req: InDesign CS3/CS4]  [Creat: 09/03/09]        */
/*                                                                     								 */
/*      Installation:                                                  							*/
/*                                                                     								  */
/*      1) Place the current file into Scripts/Scripts Panel/            		*/
/*                                                                     				  				*/
/*      2) Run InDesign, open a document , select a text frame or text */
/*                                                                    								   */
/*      3) Exec script from Window > Automatisation > Scripts               */
/*         (double-click on the script name)                           			     */
/*                                                                     								 */
/*      Bugs & Feedback : loic.aigon{at}gmail{dot}com                  	   */
/*                        www.loicaigon.com                          					  */
/*                                                                     								*/
/************************************************************************/

//======================================
// <L10N> :: FRENCH_LOCALE :: GERMAN_LOCALE
//======================================
// You need a document with text ! :: Il faut un document ouvert avec du texte !
// Please select a text frame or text to run this script. :: Il faut sélectionner un bloc texte ou du texte pour lancer ce script.
// Run this script to create random offset effects in your text. :: Utiliser ce script pour créer des effets de décalage aléatoire dans les caract\u00E8res.
// Maximum characters bottom offset :: D\u00E9calage maximum bas des caract\u00E8res:
// Maximum characters top offet :: D\u00E9calage maximum haut des caract\u00E8res:
// Offset step value :: Valeur du pas de d\u00E9calage:
// </L10N> ::
var L10N = L10N || (function()
	{
	var ln = (function()
		{ // <this> : Number
		for(var p in Locale) if(Locale[p] == this) return(p);
		}).call(app.locale);

	var parseL10N = /*str[]*/function(/*str*/locale_, /*[File]*/f)
		{
		var lines = (function()
			{ // <this> : File
			var	__com = '// ', __sep = ' :: ', __beg = '<L10N>', __end = '</L10N>';
			var l,r = [];
			var uEsc = function(){return String.fromCharCode(Number('0x'+arguments[1]));}
			if( this.open('r') )
				{
				var comSize=__com.length;
				while( !this.eof )
					{
					l = this.readln().replace(/\\u([0-9a-f]{4})/gi, uEsc);
					if( l.indexOf(__com) != 0 ) continue;
					if( l.indexOf(__end) >= 0 ) break;
					if( l.indexOf(__sep) < 0  ) continue;
					r.push(l.substr(comSize).split(__sep));
					}
				this.close();
				}
			while( (l=r.shift()) && l[0] != __beg ) {};
			return (l)?[l].concat(r):false;
			}).call(f||File(app.activeScript));

		var r=[];
		if (!lines) return r;
		var line = lines[0];
		var locIndex = (function()
			{
			for (var i=1,sz=line.length ; i<sz ; i++)
				if ( line[i] == locale_ ) return i;
			return 0;
			})();
		if (!locIndex) return r;
		
		while( line=lines.shift() )
			if ( typeof line[locIndex] != 'undefined' )
				r[line[0]] = line[locIndex];
		return r;
		}
	
	var tb = parseL10N(ln);
	__ = function(/*str*/ks){return(tb[ks]||ks);}
	return {locale: ln};
	})();

//Lance le script
Main();


//Vérification du contexte
function validContext()
{
	if(app.documents.length==0)
	{
		alert(__("You need a document with text !"));
	}
	if(app.selection.length==0)
	{
		alert(__("Please select a text frame or text to run this script."));
	}
	else
	{
		var mySel = app.selection[0];
		switch (mySel.constructor.name)
		{
			case "InsertionPoint":
			case "Character":
			case "Word":
			case "TextStyleRange":
			case "Line":
			case "Paragraph":
			case "TextColumn":
			case "Text":
			case "Story":
				myTf = mySel.parent;
				return myTf;
				break;
		
			case "TextFrame":
				myTf = mySel;
				return myTf;
				break;
				
			default:
				alert(__("Please select a text frame or text to run this script."));
			break;
		}
	}
}


function Main()
{
	if(validContext())
	{
		var myTf = validContext();
		myDlg();
	}
}

//Décale tous les caractères du bloc texte sélectionné
function scribble(myTf,min,max,step)
{
	var elements = myTf.texts[0].characters.everyItem().getElements();
	var elg = elements.length;
	for(var i = 0; i < elg; i++) 
	{
	   elements[i].baselineShift = Math.floor((1/step)*(Math.random()*(max-min)+min))/(1/step);
	}
}

//Création du dialogue
function myDlg()
{
	var myDlg = app.dialogs.add({name:"TextScribbler 1.1. \u00A9www.loicaigon.com"});
	with(myDlg)
	{
		var mySteps = ["0.1 pt","0.2 pt","0.5 pt","1 pt","2 pt","5 pt","10 pt"];
		with(dialogColumns.add())
		{
			staticTexts.add({staticLabel:__("Run this script to create random offset effects in your text.")});
			with(borderPanels.add()){
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:__("Maximum characters bottom offset")});
					staticTexts.add({staticLabel:__("Maximum characters top offet")});
					staticTexts.add({staticLabel:__("Offset step value")});
				}
				with(dialogColumns.add()){
					minShift = measurementEditboxes.add({editValue:-1, editUnits:MeasurementUnits.points, minWidth:82});
					maxShift = measurementEditboxes.add({editValue:1, editUnits:MeasurementUnits.points, minWidth:82});
					stepValue = dropdowns.add({stringList:mySteps, selectedIndex:2});
				}
			}
		}	
	}
	if(myDlg.show())
	{
		var min = minShift.editValue;
		var max = maxShift.editValue;
		var step = Number(mySteps[stepValue.selectedIndex].split(" pt")[0]);
		scribble(myTf,min,max,step);
	}
	myDlg.destroy();
}